package master;

public class Logger {

    long execution_time = 0;
    long planning_time = 0;
    long parsing_time = 0;
    long fetching_time = 0;
    long fetching_time_begin = 0;
    long ranges_generated = 0;
    long count = 0;
    long false_positive_count = 0;
    int logger_id;
    Query query;


    public Logger(int id) {
        this.logger_id = id;

    }


    public void setQuery(Query query) {
        this.query = query;
    }

    public void startCreateRanges(){
        this.planning_time = System.currentTimeMillis();
    }

    public void endCreateRanges(long ranges_generated) {
        this.planning_time = System.currentTimeMillis() - this.planning_time;
        this.ranges_generated = ranges_generated;
    }

    public void startExecution() {
        this.execution_time = System.currentTimeMillis();
    }

    public void endExecution(long true_positive_count, long false_positive_count){
        this.execution_time = System.currentTimeMillis() - this.execution_time;
        this.count = true_positive_count;
        this.false_positive_count = false_positive_count;
    }

    public void startFetching() {
        this.fetching_time_begin = System.currentTimeMillis();
    }

    public void startParsing() {
        this.parsing_time = System.currentTimeMillis();
    }

    public void endParsing() {
        this.parsing_time = System.currentTimeMillis() - this.parsing_time;
    }

    public void endFetching() {
        this.fetching_time =+ System.currentTimeMillis() - this.fetching_time_begin;
    }

    public double falseDiscoveryRate() {
        return (double) this.false_positive_count / (this.count + this.false_positive_count);

    }

    public void printLog() {
        System.out.println("Number of candidate ranges generated: " + this.ranges_generated);
        System.out.println("Seconds spent on query planning: " + this.planning_time);
        System.out.println("False discovery rate: : " + this.falseDiscoveryRate());
        System.out.println("Seconds spent on executing query: " + this.execution_time);
        System.out.println("Seconds spent total: " + (this.planning_time + this.execution_time));
        System.out.println("Number of features found: " + this.count);
    }








}
