package master;

import org.locationtech.jts.geom.Coordinate;
import org.locationtech.jts.geom.Geometry;
import org.locationtech.jts.geom.Polygon;

public class QueryRegion {


    long z_bound_lower;
    long z_bound_upper;
    long temporal_offset_min;
    long temporal_offset_max;
    long epoch;
    Polygon polygon;


    public QueryRegion(int bits, Polygon polygon) {

        this.polygon = polygon;

        Geometry bounding_box = polygon.getEnvelope();

        Coordinate[] bounding_box_coordinates = bounding_box.getCoordinates();

        Coordinate minx_miny = bounding_box_coordinates[0];
        Coordinate maxx_maxy = bounding_box_coordinates[2];

        ZorderCurve m = new ZorderCurve(2);

        this.z_bound_lower = m.encodeZaddress(new long[]{(long) minx_miny.x, (long) minx_miny.y});
        this.z_bound_upper = m.encodeZaddress(new long[]{(long) maxx_maxy.x, (long) maxx_maxy.y});

    }

    public QueryRegion(int bits, Polygon polygon, long temporal_offset_min, long temporal_offset_max, long epoch) {

        this.polygon = polygon;
        this.temporal_offset_min = temporal_offset_min;
        this.temporal_offset_max = temporal_offset_max;
        this.epoch = epoch;
        ZorderCurve m = new ZorderCurve(3);

        Geometry bounding_box = polygon.getEnvelope();

        Coordinate[] bounding_box_coordinates = bounding_box.getCoordinates();

        Coordinate minx_miny = bounding_box_coordinates[0];
        Coordinate maxx_maxy = bounding_box_coordinates[2];

        this.z_bound_lower = m.encodeZaddress(new long[]{(long) minx_miny.x, (long) minx_miny.y, temporal_offset_min});
        this.z_bound_upper = m.encodeZaddress(new long[]{(long) maxx_maxy.x, (long) maxx_maxy.y, temporal_offset_max});

    }

}
