package master;

public class ZorderCurve {

    int dimensions;
    long[] masks;
    long[] shifts;


    public ZorderCurve(int dimensions) {

        this.dimensions = dimensions;

        if (dimensions == 2) {

            this.masks = new long[]{
                    0x5555555555555555L,
                    0x3333333333333333L,
                    0x0F0F0F0F0F0F0F0FL,
                    0x00FF00FF00FF00FFL,
                    0x0000FFFF0000FFFFL,
                    0x7FFFFFFFL};
            this.shifts = new long[]{
                    1, 2, 4, 8, 16};


        } else

        {
            this.masks = new long[]{
                    0x1249249249249249L,
                    0x10C30C30C30C30C3L,
                    0x100F00F00F00F00FL,
                    0x1F0000FF0000FFL,
                    0x1F00000000FFFFL,
                    0x1FFFFFL};
            this.shifts = new long[]{
                    2, 4, 8, 16, 32};

        }

    }

    public long encodeZaddress(long[] values) {

        long address = 0L;
        for (int i = 0; i < this.dimensions; i++) {
            for (int j = shifts.length - 1; j >= 0; j--) {
                values[i] = (values[i] | (values[i] << this.shifts[j])) & this.masks[j];

            }
        }
        for (int i = 0; i < this.dimensions; i++) {
            address |= values[i] << i;
        }
        return address;

    }


    public long[] decodeZaddress(long address) {
        long[] coordinates = new long[this.dimensions];

        for (int i = 0; i < this.dimensions; i++) {
            long coordinate = address >> i;
            coordinate = coordinate & this.masks[0];
            for (int j = 0; j < shifts.length; j++) {
                coordinate = (coordinate | (coordinate >> this.shifts[j])) & this.masks[j + 1];
            }
            coordinates[i] = coordinate;
        }

        return coordinates;

    }

}
